/* TNdrvr.h -- copyright 1989 Cornell University */

#define HTN_OPEN	100
#define HTN_CONNECT	101
#define HTN_CLOSE	102
#define HTN_QUIT	103
#define HTN_SENDSTR	104
#define HTN_SENDCMD	105
#define HTN_CURSOR	106
#define HTN_DRAW	107
#define HTN_STATUS	108

#define HTN_INIT	200

/* failure codes */

#define HTNR_NOTN	-1001
#define HTNR_ACTIVE	-1002
#define HTNR_OPEN	-1003
#define HTNR_NAME	-1004
#define HTNR_ADDR	-1005
#define HTNR_CLASS	-1006
#define HTNR_ENTRY	-1007

/* status codes */

#define HTNS_RUNNING	0
#define HTNS_WAITCONN	-2000
#define HTNS_NEWDATA	-2001
#define HTNS_WAITNET	-2002
#define HTNS_KBDLOCK	-2003
#define HTNS_MORE		-2004
#define HTNS_HOLDING	-2005
#define HTNS_CP			-2006
#define HTNS_VMREAD		-2007

/* misc. */

#define HTNI_BUFSIZE	1945	/* (24 * 80) + 24 (CRs) + 1 NULL terminator */
#define ROW_SIZE		  80	/* 80 chars per row */
#define ATTR			  32	/* high bit set on tn3270 attributes */
#define CR				0x0D	/* carriage return character */

struct storage {
	/* 3270 pointers to routines */
	OSErr (*tnopen)();
	OSErr (*tnconnect)();
	OSErr (*tnstatus)();
	OSErr (*tnclose)();
	OSErr (*tnquit)();
	OSErr (*tnsendstr)();
	OSErr (*tnsendcmd)();
	OSErr (*tndraw)();

	/* 3270 pointers to data */
	char * tnscreen;				/* ptr to tn3270 buffer */
	char ** tncursor;				/* ptr to tn3270 cursor */
	char ** tnfield;				/* ptr to tn3270 field * */

	/* Hypercard pointers to data */
	Handle hycflag;					/* hypercard "data ready" flag Handle */
};

