/*
 * bridgeDA.r
 *
 * Copyright 1988 Cornell University
 */

#include "Types.r"	
#include "MPWTypes.r"	

type 'DRVR' as 'DRVW';

#define DriverID	28

resource 'DRVR' (DriverID, "\0x00.TNdrvr", sysheap, locked) {
	dontNeedLock,			/* OK to float around, not saving ProcPtrs */
	dontNeedTime,			/* No, dont give us periodic Control calls */
	dontNeedGoodbye,		/* No special requirements */
	noStatusEnable,
	ctlEnable,				/* Desk accessories only do Control calls */
	noWriteEnable,
	noReadEnable,
	0,						/* drvrDelay - Wake up AFAP */
	updateMask, 			/* drvrEMask - This DA only handles update events */
	0,						/* drvrMenu - This DA has no menu */
	".TNdrvr",				/* drvrName - This isn't used by the DA */
	/*
	 * This directive inserts the contents of the DRVW resource
	 * produced by linking DRVRRuntime.o with our DA code
	 */
	$$resource("TNdrvr.DRVW", 'DRVW', 0)
};

