/*
	Copyright Cornell University 1986.  All rights are reserved.
	menudefs.h -- assorted menu definiations for telnet 
*/

#define	NAMESIZE	40

#define	applemenu	0x61
#define	filemenu	0x62
#define	ctrlmenu	0x63
#define	netmenu		0x64
#define	sendmenu	0x65		
#define	curkeymenu	0x66
#define	pfkeymenu	0x67
#define	asc1keymenu	0x68
#define	asc2keymenu	0x69
#define	helpmenu	0x6a
#define	editmenu	0x6b
#define	fsizemenu	0x6c
#define	windmenu	0x6d
#define	serialmenu	0x6e
#define	serialsendmenu	0x6f

#define APPLEMENU	0
#define FILEMENU	1
#define EDITMENU	2
#define WINDMENU	3
#define CTRLMENU	4
#define HELPMENU	5

#define	NIBMMENUS	6

#define NETWORKMENU	6
#define SENDMENU	7
#define ASC1KEYMENU	8
#define ASC2KEYMENU	9
#define PFKEYMENU	10
#define CURKEYMENU	11
#define FSIZEMENU	12
#define SERIALMENU	13
#define SERSENDMENU	14
#define	NMENUS		15

/* apple menu options */
#define ABOUT_COMET		1
#define BUGREPORT		2
#define SKIPAPPLE	3
#define TNDIALOG	256

#define COMET_HELP	2

/* file menu options */

#define NEWCONN			1
#define OPENCONN		2
#define WMCLOSEWIND		3
#define SAVECONF		4
	/* skip */
#define FILENAME		6
	/* skip */
#define SAVESCREENAS	8
#define APPENDSCREENTO	9
#define SAVESCREEN		10
#define APPENDSCREEN	11
#define LOGOPEN			12
#define FILESESSION		13
	/* skip */
#define PRINTLAYOUT	15
#define PRINTQD		16
	/* skip */
#define QUIT		18


/* edit menu options */

#define EDUNDO		1
	/* skip */
#define EDCUT		3
#define EDCOPY		4
#define EDPASTE		5
#define EDCLEAR		6
#define EDSELALL	7
#define EDTABLEMODE		8
	/* skip per window... */
#define EDLOAD		10
#define EDAPPEND	11
#define LOGSESSION	12
#define EDPAGEUP	13
#define EDPAGEDOWN	14
#define EDGOTOEND	15
#define EDFIND		16
#define EDFINDSEL	17
#define EDWRAP		18
#define EDUNWRAP	19

/* session menu */
#define CLOSECONN		1
#define REOPENCONN		2
#define RECONF			3
#define WMROTATE		4
#define WMSKIPWIND		5
#define WMFIRSTWIND		6


/* network menu options */
#define SENDADDR	1
#define SENDHIER	2
#define NETSTAT		3
#define ENDOFLINE	4
#define LOCALECHO	5
	/* skip */
#define MYADDR		7
#define HOSTADDR	8
#define HOSTNAME	9
#define GATEADDR	10

/* send menu options */
#define ERASECHAR	1
#define ERASELINE	2
#define YOUTHERE	3
#define INTERRUPT	4
#define ABORT		5
#define BREAK		6


/* old keypad junk */
#define MNORMKEYPAD	4
#define MKEYPAD1	5
#define MKEYPAD2	6
#define MKEYPAD3	7

/* control menu options */
#define MSETGLOBAL	1
#define MSETWIND	2
#define MSETEM		3
#define MFONTSIZE	4
#define MSETCOLOR	5
	/* skip */
#define MSHOWKEYPAD	7
#define KEYXSHOW	8
#define KEYXSET		9
#define KEYXON		10
	/* skip */
#define MCONNMACRO	12
#define MCLIKMACRO	13

/* #define MCLOSEMACRO	14 */

	/* skip  */
#define MTYPEAHEAD	13	/* IBM related stuff */
#define BLANKNULLS	14
#define SQUEEZEBLANKS	15
#define SHIFTFIELD	16
	/* skip */
#define ESCMAP		18	/* ASCII control stuff -- swap menus? */
#define BABS		19
#define CRTONL		20
#define EOLWRAP		21
#define CURSTRACK	22

#define MAUTOSHRINK	1
#define CURSHAPE	5
#define CURFLASH	6

#define REFRESH		23
#define FILLSCREEN	24


/* ibmcurs menu--ibm right-hand cursor motion key pad */

#define MUP			1
#define MDOWN		2
#define MLEFT		3
#define MRIGHT		4
#define MHOME		5
#define MBS			6
#define MBSDEL		7
#define MBSBLANK	8
#define MDEL		9
#define MERASEEOF	10
#define MERASEINPUT	11
#define MTAB		12
#define MBACKTAB	13
#define MINSERT		14
#define MNEWLINE	15
#define MRESET		16

/* ibmpfkey menu */

#define MENTER		1
#define MPA1		2
#define MPA2		3
#define MPA3		4
#define MCLEAR		5
#define MPF1		6
#define MPF2		7
#define MPF3		8
#define MPF4		9
#define MPF5		10
#define MPF6		11
#define MPF7		12
#define MPF8		13
#define MPF9		14
#define MPF10		15
#define MPF11		16
#define MPF12		17


/* help menu */
#define INFOBACK			1
#define INFOABOUTASCII		2
#define INFOABOUTIBM		3
#define INFOMACROS			4
#define INFOFILE			5
#define INFOEDIT			6
#define INFOWIND			7
#define INFOTN				8
#define INFOSERIAL			9
#define INFOCONTROL			10
#define INFOASCII			11
#define INFOIBM				12
	/* skip */
	/* skip "click to return" */
	/* skip */
#define DUMPINFO				16
#define DUMPINFO2				17

#define TEXTABOUT		2000

#define ITEXTBACK		2001
#define ITEXTABOUTASCII		2002
#define ITEXTABOUTIBM		2003
#define ITEXTFILE		2004
#define ITEXTEDIT		2005
#define ITEXTWIND		2006
#define ITEXTTN			2007
#define ITEXTSERIAL		2008
#define ITEXTCONTROL	2009
#define ITEXTASCII		2010
#define ITEXTIBM		2011
#define ITEXTMACROS		2012


/* unused through texttftp */
#define TEXTVERS		1001
#define TEXTOTHER		1002
#define TEXTPLANS		1003
#define TEXTSAVECONF	1005
#define TEXTTYPEAHEAD	1006
#define TEXTNULLS		1009		/* 3270 nulls options help */
#define TEXTBS			1010		/* backspace help */

#define TEXTFT3270		1004
#define TEXTTFTP		1007	/* tftp help */



#define TEXTLOGON		1008	/* logon help */
#define TEXTWINDDLOG	1011	/* window configuration dialog help */
#define TEXTGLOBALDLOG	1012	/* window configuration dialog help */
#define TEXTEMDLOG		1013	/* window emulator configuration dialog help */
#define TEXT3270DLOG	1014	/* 3270 window emulator configuration dialog help */


#define TEXTNORMKEYP	20000
#define TEXTKEYP1		20001
#define TEXTKEYP2		20002
#define TEXTKEYP3		20003

#define ASCMENUDEL	19	/* DEL item in ASC2KEYMENU */

/* serialmenu items  */


/* Param menu options--control serial data, parity, & stop bits */

#define SERSENDHIER	1
#define SERAUTOHANG	2
/* skip */
#define BAUD57600	4
#define BAUD38400	5
#define BAUD19200	6
#define BAUD9600	7
#define BAUD4800	8
#define BAUD2400	9
#define BAUD1200	10
#define BAUD300		11
/* skip */
#define DATA8		13
#define DATA7		14
#define DATA6		15
/* skip */
#define PARITYNONE	17
#define PARITYEVEN	18
#define PARITYODD	19
/* skip */
#define STOP2		21
#define STOP1HALF	22
#define STOP1		23
/* skip */
#define SERPORTHANGUP		25
#define SERPORTRESET		26


#define NUMBAUDS	6

/* number of Param items for range checking when checking menu items */

#define DATAITEMS	3
#define PARITYITEMS	3
#define STOPITEMS	3


/* serialmenu send items  */

#define SYTEKESCAPE		1
#define ALTSYTEKESCAPE	2


/* flags for get_host, which button to highlight */
#define GH_OPEN	1
#define GH_QUIT	2
#define GH_SET	3



