{This header file is really just to keep your external project from getting out of control.}
{The info in this file is just copied from various interface files.  If you need to use any of these}
{files you will need to remove the parts of this file that come from that file.  To make}
{this easier I have marked each where each section comes from.  If you need to add any of}
{these files then you can simply remove that file's particular section.  Below is a list of all}
{header files that are currently used in this file.}
{}
{Interface files contained in this one:  }
{}
{Processes.p}
{AppleEvents.p}
{Sound.p}
{Shutdown.p}

unit MiscIntf;

interface

{------------------------------------ Processes.p Begin --------------------------------------}
	const
{ Various reserved process serial numbers.}
		kNoProcess = 0;
		kSystemProcess = 1;
		kCurrentProcess = 2;
	type
{ type for unique process identifier }
		ProcessSerialNumberPtr = ^ProcessSerialNumber;
		ProcessSerialNumber = record
				highLongOfPSN: LONGINT;
				lowLongOfPSN: LONGINT;
			end;
{ Record returned by GetProcessInformation }
		ProcessInfoRecPtr = ^ProcessInfoRec;
		ProcessInfoRec = record
				processInfoLength: LONGINT;
				processName: StringPtr;
				processNumber: ProcessSerialNumber;
				processType: LONGINT;
				processSignature: OSType;
				processMode: LONGINT;
				processLocation: Ptr;
				processSize: LONGINT;
				processFreeMem: LONGINT;
				processLauncher: ProcessSerialNumber;
				processLaunchDate: LONGINT;
				processActiveTime: LONGINT;
				processAppSpec: FSSpecPtr;
			end;
	function GetFrontProcess (var PSN: ProcessSerialNumber): OSErr;
	inline
		$70FF, $2F00, $3F3C, $0039, $A88F;
	function GetNextProcess (var PSN: ProcessSerialNumber): OSErr;
	inline
		$3F3C, $0038, $A88F;
	function GetProcessInformation (PSN: ProcessSerialNumber; var info: ProcessInfoRec): OSErr;
	inline
		$3F3C, $003A, $A88F;
	function SetFrontProcess (PSN: ProcessSerialNumber): OSErr;
	inline
		$3F3C, $003B, $A88F;
	function SameProcess (PSN1: ProcessSerialNumber; PSN2: ProcessSerialNumber; var result: BOOLEAN): OSErr;
	inline
		$3F3C, $003D, $A88F;
{------------------------------------- Processes.p End ---------------------------------------}


{----------------------------------- AppleEvents.p Begin -------------------------------------}

	const
		typeChar = 'TEXT';
		typeApplSignature = 'sign';
		typeNull = 'null';                  {the type of null/nonexistent data}
		kAnyTransactionID = 0;              { no transaction is in use }
		kAutoGenerateReturnID = -1;         { AECreateAppleEvent will generate a session-unique ID }
		keyDirectObject = '----';
		kAEWaitReply = $00000003;           { Sender wants a reply and will be waiting }
		kAENeverInteract = $00000010;       { Server should not interact with user }
		kAENormalPriority = $00000000;      { Post message at the end of event queue }

	type
		AEKeyword = packed array[1..4] of CHAR;
		AEEventClass = packed array[1..4] of CHAR;
		AEEventID = packed array[1..4] of CHAR;
		DescType = ResType;

{ tagged data, the standard AppleEvent data type }
		AEDesc = record
				descriptorType: DescType;
				dataHandle: Handle;
			end;

		AEAddressDesc = AEDesc;             { an AEDesc which contains addressing data }
		AEDescList = AEDesc;                { a list of AEDesc is a special kind of AEDesc }
		AERecord = AEDescList;              { AERecord is a list of keyworded AEDesc }
		AppleEvent = AERecord;              { an AERecord that contains an AppleEvent }
		AESendMode = LONGINT;               { Type of parameter to AESend }
		AESendPriority = INTEGER;           { Type of priority param of AESend }

		IdleProcPtr = ProcPtr;
		EventFilterProcPtr = ProcPtr;

	function AECreateDesc (typeCode: DescType; dataPtr: Ptr; dataSize: Size; var result: AEDesc): OSErr;
	inline
		$303C, $0825, $A816;
	function AECreateAppleEvent (theAEEventClass: AEEventClass; theAEEventID: AEEventID; target: AEAddressDesc; returnID: INTEGER; transactionID: LONGINT; var result: AppleEvent): OSErr;
	inline
		$303C, $0B14, $A816;
	function AESend (theAppleEvent: AppleEvent; var reply: AppleEvent; sendMode: AESendMode; sendPriority: AESendPriority; timeOutInTicks: LONGINT; idleProc: IdleProcPtr; filterProc: EventFilterProcPtr): OSErr;
	inline
		$303C, $0D17, $A816;
	function AEPutParamPtr (theAppleEvent: AppleEvent; theAEKeyword: AEKeyword; typeCode: DescType; dataPtr: Ptr; dataSize: Size): OSErr;
	inline
		$303C, $0A0F, $A816;
	function AEDisposeDesc (var theAEDesc: AEDesc): OSErr;
	inline
		$303C, $0204, $A816;

{------------------------------------ AppleEvents.p End --------------------------------------}



{--------------------------------------- Sound.p Begin ---------------------------------------}
	const
		stdQLength = 128;
		StdQLengthMinusOne = stdQLength - 1;
		freeCmd = 2;
	type
		Time = LONGINT;                                 { in half milliseconds }
		SndCommand = packed record
				cmd: INTEGER;
				param1: INTEGER;
				param2: LONGINT;
			end;
		SndChannelPtr = ^SndChannel;
		SndChannel = packed record
				nextChan: SndChannelPtr;
				firstMod: Ptr;                              { reserved for the Sound Manager }
				callBack: ProcPtr;
				userInfo: LONGINT;
				wait: Time;                                 { The following is for internal Sound Manager use only.}
				cmdInProgress: SndCommand;
				flags: INTEGER;
				qLength: INTEGER;
				qHead: INTEGER;                             { next spot to read or -1 if empty }
				qTail: INTEGER;                             { next spot to write = qHead if full }
				queue: array[0..stdQLengthMinusOne] of SndCommand;
			end;
	function SndDoCommand (chan: SndChannelPtr; cmd: SndCommand; noWait: BOOLEAN): OSErr;
	inline
		$A803;
	function SndNewChannel (var chan: SndChannelPtr; synth: INTEGER; init: LONGINT; userRoutine: ProcPtr): OSErr;
	inline
		$A807;
	function SndDisposeChannel (chan: SndChannelPtr; quietNow: BOOLEAN): OSErr;
	inline
		$A801;
	function SndPlay (chan: SndChannelPtr; sndHdl: Handle; async: BOOLEAN): OSErr;
	inline
		$A805;
{---------------------------------------- Sound.p End ---------------------------------------}

{-------------------------------------- Shutdown.p Begin ------------------------------------}
	procedure ShutDwnPower;
	inline
		$3F3C, $0001, $A895;
	procedure ShutDwnStart;
	inline
		$3F3C, $0002, $A895;
{--------------------------------------- Shutdown.p End -------------------------------------}

implementation
end.