#include <CLEvents.h>

/**********************************
 *
 *  SendAddUserToCallLog
 *
 *  This routine sends an 'Add User' event to
 *  the call log.  Passed in is a target ID
 *  and the fields to show stats.
 *
 ***************************/

short SendAddUserToCallLog( TargetID *tid, Byte* userName, Byte* bbsName, long logonTime, \
				long elapsedTime, long kbUpload, long kbDownload, long numEMail, \
				long numPosted, long connectBPS, long callerNum, short callErrorCode )
{
	AppleEvent		evt, reply;
	AEAddressDesc	adsc = { 0,0 };
	short			err, aeErr = noErr, myErr;
	long			type, size;
	
	err = AECreateDesc ( typeTargetID, (void *) tid, sizeof( TargetID ), &adsc ) ;

	if ( !err )
	{	err = AECreateAppleEvent ( clClass, clAddCaller, &adsc, kAutoGenerateReturnID,
			kAnyTransactionID, &evt );

		if ( !err )
		{	
			if ( !err )
			{	if ( userName )
					err = AEPutParamPtr ( &evt, clUserName, typeChar, (void *) &userName[1], (long)userName[0] );
				else
					err = AEPutParamPtr ( &evt, clUserName, typeChar, (void *) "\p", (long)1 );
			}
			
			if ( !err )
				err = AEPutParamPtr ( &evt, clBBSName, typeChar, (void *) &bbsName[1], (long)bbsName[0] );
		
			if ( !err )
				err = AEPutParamPtr ( &evt, clLogonTime, typeLongInteger, (void *) &logonTime, (long)4L );
		
			if ( !err )
				err = AEPutParamPtr ( &evt, clElapsedTime, typeLongInteger, (void *) &elapsedTime, (long)4L );
		
			if ( !err )
				err = AEPutParamPtr ( &evt, clKbUpload, typeLongInteger, (void *) &kbUpload, (long)4L );
		
			if ( !err )
				err = AEPutParamPtr ( &evt, clKbDownload, typeLongInteger, (void *) &kbDownload, (long)4L );
		
			if ( !err )
				err = AEPutParamPtr ( &evt, clNumEMail, typeLongInteger, (void *) &numEMail, (long)4L );
		
			if ( !err )
				err = AEPutParamPtr ( &evt, clNumPosted, typeLongInteger, (void *) &numPosted, (long)4L );
		
			if ( !err )
				err = AEPutParamPtr ( &evt, clConnectBPS, typeLongInteger, (void *) &connectBPS, (long)4L );
		
			if ( !err )
				err = AEPutParamPtr ( &evt, clCallNum, typeLongInteger, (void *) &callerNum, (long)4L );
		
			if ( !err )
				err = AEPutParamPtr ( &evt, clCallErrorCode, typeSMInt, (void *) &callErrorCode, (long)2L );
		

			if ( ! err )
				err = AESend ( &evt , &reply , kAEWaitReply | kAENeverInteract | kAEWantReceipt,
					kAENormalPriority, kAEDefaultTimeout , NULL , NULL );
		
			if ( !err )
			{
				err = AEGetParamPtr( &reply, keyErrorNumber, typeSMInt, (void *) &type, (void *) &aeErr, sizeof( short ), (void *) &size );
				
				if ( err == errAEDescNotFound )
				{
					err = noErr;
					aeErr = noErr;
				}
				
				myErr = AEDisposeDesc( &reply );
			}
			
			myErr = AEDisposeDesc( &evt );
		}
		myErr = AEDisposeDesc( &adsc );
	}
	if ( !err )
		return( aeErr );
	else
		return( err );
}


short SendNewCallerLog( TargetID *tid, Byte* userName, Byte* bbsName, long logonTime, long connectBPS, long *callNum )
{
	AppleEvent		evt, reply;
	AEAddressDesc	adsc = { 0,0 };
	short			err, aeErr = noErr, myErr;
	long			type, size;
	
	err = AECreateDesc( typeTargetID, (void *)tid, sizeof( TargetID ), &adsc ) ;

	if ( !err )
	{	err = AECreateAppleEvent ( clClass, clNewCaller, &adsc, kAutoGenerateReturnID, kAnyTransactionID, &evt );

		if ( !err )
		{	
			if ( !err )
				err = AEPutParamPtr ( &evt, clUserName, typeChar, (void *) &userName[1], (long)userName[0] );

			if ( !err )
				err = AEPutParamPtr ( &evt, clBBSName, typeChar, (void *) &bbsName[1], (long)bbsName[0] );
		
			if ( !err )
				err = AEPutParamPtr ( &evt, clLogonTime, typeLongInteger, (void *) &logonTime, (long)4L );
		
			if ( !err )
				err = AEPutParamPtr ( &evt, clConnectBPS, typeLongInteger, (void *) &connectBPS, (long)4L );
		
			if ( ! err )
				err = AESend ( &evt , &reply , kAEWaitReply | kAENeverInteract | kAEWantReceipt,
					kAENormalPriority, kAEDefaultTimeout , NULL , NULL );
		
			if ( !err )
			{
				err = AEGetParamPtr( &reply, keyErrorNumber, typeSMInt, (void *) &type,
					(void *) &aeErr, sizeof( short ), (void *) &size );
				if ( err == errAEDescNotFound )
				{
					err = noErr;
					aeErr = noErr;
				}
				
				if ( !err && !aeErr )
					err = AEGetParamPtr( &reply, clCallNum, typeLongInteger, (void*)&type, (void*)callNum, 4L, (void *) &size );

				myErr = AEDisposeDesc( &reply );
			}
			
			myErr = AEDisposeDesc( &evt );
		}
		
		myErr = AEDisposeDesc( &adsc );
	}
	
	if ( !err )
		return( aeErr );
	else
		return( err );
}
