#include <AppleEvents.h>
#include <Aliases.h>

#include <FLEvents.h>


short SendFileXfrToLog( TargetID *tid, Byte* userName, Byte* bbsName, FSSpec *xfrFSpec, int fileXfrCode, int dirType, \
				long elapsedTime, int numRetransmits, long bytesSent, long fileSize, long connectBPS, \
				long cpsThruPut, long dateTimeComplete )
{
	AppleEvent		evt, reply;
	AEAddressDesc	adsc = { 0,0 };
	short			err, aeErr = noErr, myErr;
	long			type, size;
	AliasHandle		xfrAlias= 0L;
	
	err = AECreateDesc ( typeTargetID, (void *) tid, sizeof( TargetID ), &adsc ) ;

	if ( !err )
	{	err = AECreateAppleEvent ( flClass, flAddFileToList, &adsc, kAutoGenerateReturnID,
			kAnyTransactionID, &evt );

		if ( !err )
		{	
			if ( !err )
				err = AEPutParamPtr ( &evt, flUserName, typeChar, (void *) &userName[1], (long)userName[0] );

			if ( !err )
				err = AEPutParamPtr ( &evt, flBBSName, typeChar, (void *) &bbsName[1], (long)bbsName[0] );
		
			if ( !err )
				err = NewAliasMinimal( xfrFSpec, &xfrAlias );
			
			if ( !err )
			{
				if ( !err )
				{	HLock( xfrAlias );
					err = AEPutParamPtr( &evt, flFileSpec, typeAlias, (void*)*xfrAlias, GetHandleSize( xfrAlias ) );
					HUnlock( xfrAlias );
				}
		
				if ( !err )
					err = AEPutParamPtr ( &evt, flXfrCode, typeSMInt, (void *) &fileXfrCode, 2L );
			
				if ( !err )
					err = AEPutParamPtr ( &evt, flDirType, typeSMInt, (void *) &dirType, 2L );
			
				if ( !err )
					err = AEPutParamPtr ( &evt, flElapsedTime, typeLongInteger, (void *) &elapsedTime, 4L );
			
				if ( !err )
					err = AEPutParamPtr ( &evt, flBytesSent, typeLongInteger, (void *) &bytesSent, 4L );
			
				if ( !err )
					err = AEPutParamPtr ( &evt, flRetransmit, typeSMInt, (void *) &numRetransmits, 2L );
			
				if ( !err )
					err = AEPutParamPtr ( &evt, flFileSize, typeLongInteger, (void *) &fileSize, 4L );
			
				if ( !err )
					err = AEPutParamPtr ( &evt, flBaudRate, typeLongInteger, (void *) &connectBPS, 4L );
			
				if ( !err )
					err = AEPutParamPtr ( &evt, flThruPut, typeLongInteger, (void *) &cpsThruPut, 4L );
			
				if ( !err )
					err = AEPutParamPtr ( &evt, flTimeComplete, typeLongInteger, (void *) &dateTimeComplete, 4L );
			
				if ( ! err )
					err = AESend ( &evt , &reply , kAEWaitReply | kAENeverInteract | kAEWantReceipt,
						kAENormalPriority, kAEDefaultTimeout , NULL , NULL );
			
				if ( !err )
				{
					err = AEGetParamPtr( &reply, keyErrorNumber, typeSMInt, (void *) &type,
						(void *) &aeErr, sizeof( short ), (void *) &size );
						
					if ( err == errAEDescNotFound )
					{
						err = noErr;
						aeErr = noErr;
					}
	
					myErr = AEDisposeDesc( &reply );
				}
				
				if ( xfrAlias )
					DisposHandle( xfrAlias );
			}
			
			myErr = AEDisposeDesc( &evt );
		}
		myErr = AEDisposeDesc( &adsc );
	}
	if ( !err )
		return( aeErr );
	else
		return( err );
}

short SendStartFL( TargetID *tid, FSSpec *partialsFile )
{
	AppleEvent		evt, reply;
	AEAddressDesc	adsc = { 0,0 };
	short			err, aeErr, myErr;
	long			type, size;
	
	err = AECreateDesc ( typeTargetID, (void *) tid, sizeof( TargetID ), &adsc ) ;

	if ( !err )
	{	err = AECreateAppleEvent ( flClass , flGetPartialFile, &adsc, kAutoGenerateReturnID, kAnyTransactionID, &evt );
	
		if ( !err )
		{	err = AESend ( &evt , &reply , kAEWaitReply | kAENeverInteract | kAEWantReceipt,
				kAENormalPriority, 60*60*5 , NULL , NULL );
	
			if ( !err )
			{
				err = AEGetParamPtr( &reply, keyErrorNumber, typeSMInt, (void *) &type,
					(void *) &aeErr, sizeof( short ), (void *) &size );
					
				if ( err == errAEDescNotFound )
				{
					err = noErr;
					aeErr = noErr;
				}

				if ( !err && !aeErr )
				{	err = AEGetParamPtr( &reply, flFileSpec, typeFSS, (void *) &type,
						(void *) partialsFile, sizeof( FSSpec ), (void *) &size );
				
				}

				myErr = AEDisposeDesc( &reply );
			}
			
			myErr = AEDisposeDesc( &evt );
		}
			
		myErr = AEDisposeDesc( &adsc );
	}
	
	if ( !err )
		return( aeErr );
	else
		return( err );
}

