/* 

user access file for TeleFinder Group Edition 2.6 (c)1992
Spider Island Software ALL RIGHTS RESERVED

The user access file defines paths that users have access to
They can be defined as either download type paths, or conference paths

The records are stored as fixed length records in no specific order.
( note the index field will be used to sort the data in the furture )

*/
// USER ACCESS FILE

#ifndef USER_ACCESS_FILE
#define USER_ACCESS_FILE

#define		RFDType		0x14				/* file download */
#define		Rfile		0x18				/* any file */
#define		RCommObj	0x1F

#define		MailFldr	0x21				/* user mail folder */
#define		ConfFldr	0x22				/* conference */

#define		RMailFldr	0x41				/* drop box icon */

#define		kUploadsFolder	0x42			// host defined folder for uploads

typedef struct AccessRec
{
	short	 		vRef;
	long			DirID;
	Str255			path;
	Str32			DirName;
	Str32			info_fName;
	short			ObjType;
	short			icon_id;
	unsigned short	path_flags0_;	
	unsigned short	path_flags1_;
	Byte			spare[24];
	short			index;
	Str255			description;
} AccessRec, *AccessRecPtr, **AccessRecHdl;


typedef struct
{
	Byte			version;
	long			RecSize;
	long			NumRecs;
	int				modified;
} access_hdr;


typedef struct
{
	access_hdr		FileHeader;
	Byte			fName[65];
	int				vRef;
	long			DirID;
	AccessRecHdl	Records[];
} AccessData, *AccessDataPtr, **AccessDataHdl;


// flags in path_flags0_
#define access_create 			(unsigned short)0x0001
#define access_delete 			(unsigned short)0x0002
#define access_see_folders		(unsigned short)0x0004
#define access_see_files		(unsigned short)0x0008

#define access_send_file_always		(unsigned short)0x0010

#define access_no_can_download		(unsigned short)0x0020
#define access_no_create_threads	(unsigned short)0x0040
#define access_no_new_folder		(unsigned short)0x0080

// file type for this file
#define PATH_TYPE 'plst'

#endif